Subject: bug#28756: Substitute download progress bar doesn't reach 100%

From: [email-masked] (宋文武)
Date: Sat, 14 Oct 2017 23:05:15 +0800

[email-masked] (宋文武) writes:

> [email-masked] (Ludovic Courtès) writes:
>
>> Hello,
>>
>> Leo Famulari <[email-masked]> skribis:
>>
>>> I just upgraded to the latest Guix and, while downloading substitutes, I
>>> noticed the progress bar seems to never reach 100%, as shown below. I'm
>>> not sure if this started recently or not.
>>>
>>> Downloading https://mirror.hydra.gnu.org/guix/nar/gzip/drm4pj1k5mkb5784i0rkqb0bg2z8lmyw-libabw-0.1.1...
>>>  libabw-0.1.1  346KiB
>>
>> Indeed, I’ve noticed too, and I think it relates to the new progress
>> reporters.  宋文武, do you experience this as well?  Thoughts?
>>
>
> Yes, thanks for the report, commit abaee53c8 should fix it.
>

Well, it didn't...  I have to learn it's a child process will read and
report the process:

>From 93b42f62ece1ad5181ed1119fc750bcbb74c5d3c Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=AE=8B=E6=96=87=E6=AD=A6?= <[email-masked]>
Date: Sat, 14 Oct 2017 22:45:55 +0800
Subject: [PATCH] guix: substitute: Report the last process in the child
 process.

Fixes <https://bugs.gnu.org/28756>.

* guix/utils.scm (filtered-port): Close the 'input' port in the child process.
* guix/scripts/substitute.scm (progress-substitution): Close the 'progress'
port before 'restore-file'.
---
 guix/scripts/substitute.scm | 10 ++++++----
 guix/utils.scm              |  1 +
 2 files changed, 7 insertions(+), 4 deletions(-)

diff --git a/guix/scripts/substitute.scm b/guix/scripts/substitute.scm
index 921a7c679..d175d3e84 100755
--- a/guix/scripts/substitute.scm
+++ b/guix/scripts/substitute.scm
@@ -959,16 +959,18 @@ DESTINATION as a nar file.  Verify the substitute against ACL."
                    (decompressed-port (and=> (narinfo-compression narinfo)
                                              string->symbol)
                                       progress)))
+      ;; A child process of 'decompressed-port' will read from this 'process'
+      ;; port and thus report the actual progress to the console.  As the
+      ;; parent process, we should close it at the start.
+      (close-port progress)
       ;; Unpack the Nar at INPUT into DESTINATION.
       (restore-file input destination)
       (close-port input)
-      (close-port progress)
+      (every (compose zero? cdr waitpid) pids)
 
       ;; Skip a line after what 'progress-reporter/file' printed, and another
       ;; one to visually separate substitutions.
-      (display "\n\n" (current-error-port))
-
-      (every (compose zero? cdr waitpid) pids))))
+      (display "\n\n" (current-error-port)))))
 
 
 ;;;
diff --git a/guix/utils.scm b/guix/utils.scm
index de4aa6531..f8cf11ccb 100644
--- a/guix/utils.scm
+++ b/guix/utils.scm
@@ -153,6 +153,7 @@ buffered data is lost."
                   (close-port in)
                   (dump-port input out))
                 (lambda ()
+                  (close input)
                   (false-if-exception (close out))
                   (primitive-_exit 0))))
              (child
-- 
2.13.3

With this patch, update the guix snapshot and do a system reconfigure,
this issue should be fixed!